//=============================================================================
// GotchaBitchMut by SC]-[LONG_{HoF}  January 2012.
// Revised: by SC]-[WARTZ_{HoF} formerly known as "SC]-[LONG_{HoF}" January 2016.
// Changed: Using 'damagetypes' instead of 'weaponclasses' to trigger gotchabitch.
// Changed: Using function 'bool preventdeath' instead of 'scorekill'.
// Added: Configurable booleans for specific melee weapons.
// Todo: Configurable bonus for gotchabitch kills and if awarded will not exceed fraglimit.
//=============================================================================
class GotchaBitchMut expands Mutator config(GotchaBitch);

var bool 		bPostBPInitialized;		// Initialize one instance of this mutator.
var config bool	bTranslocator,		// Use the Translocator. 
		bImpactHammer,		// Use the ImpactHammer.
		bChainSaw;		// Use the ChainSaw.

event PostBeginPlay()
{
	if ( !bPostBPInitialized )
		bPostBPInitialized = True;
	SaveConfig();
	Level.Game.RegisterMessageMutator(self);
	Level.Game.RegisterDamageMutator(self);
	if ( NextMutator != None )
		NextMutator.PostBeginPlay();
}

function AddMutator(Mutator M)
{
	if ( M == none || M == self )
		return;
	else if ( M.Class != Class )
		Super.AddMutator(M);
	else if ( M != Self )
		M.Destroy();
}

function bool PreventDeath(Pawn Killed, Pawn Killer, name damageType, vector HitLocation)
{
	if ( Killed != None )
	{
		if ( Killer != Killed && Killer != None )
		{
			if ( damageType != '')
			{
				if ( bTranslocator && damageType == 'Gibbed' 
				|| bImpactHammer && damageType == 'Impact' 
				|| bChainSaw && damageType == 'slashed' )
				{
					Killed.ReceiveLocalizedMessage( class'GotchaBitchMessage' );
					Killer.ReceiveLocalizedMessage( class'GotchaBitchMessage' );
				}
			}
		}
	}
	return Super.PreventDeath(Killed,Killer,DamageType,HitLocation);
}

defaultproperties
{
     bTranslocator=True
     bImpactHammer=True
     bChainSaw=True
}
